import  java.awt.Dimension;
import  java.awt.Toolkit;
import  javax.swing.JFrame;
import  javax.swing.JDialog;
import java.awt.Point;
import java.awt.Window;
import java.util.Vector;
import java.io.File;
import java.io.Writer;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.FileInputStream;

public class Functions {

  public Functions() {
  }

    public static void centerVindu (JFrame f) {
        Dimension skjermSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension vinduSize = f.getSize();
        if (vinduSize.height > skjermSize.height) {
            vinduSize.height = skjermSize.height;
        }
        if (vinduSize.width > skjermSize.width) {
            vinduSize.width = skjermSize.width;
        }
        f.setLocation((skjermSize.width - vinduSize.width)/2, (skjermSize.height
                - vinduSize.height)/2);
  }

  public static void centerVindu (JDialog f) {
        Dimension skjermSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension vinduSize = f.getSize();
        if (vinduSize.height > skjermSize.height) {
            vinduSize.height = skjermSize.height;
        }
        if (vinduSize.width > skjermSize.width) {
            vinduSize.width = skjermSize.width;
        }
        f.setLocation((skjermSize.width - vinduSize.width)/2, (skjermSize.height
                - vinduSize.height)/2);
  }


  public String[] getExpToCmb(Vector v_exp){
    String exp[] = null;
    if(!v_exp.isEmpty()){
      exp = new String[v_exp.size()];

      for(int i=0; i<exp.length;i++){
         String tmp[] = v_exp.elementAt(i).toString().split("#");
         exp[i] = tmp[1];
      }
    }
    return exp;
  }

  public int getExpIndex(int cmbindex, Vector v_exp){
    if(!v_exp.isEmpty()){
         String tmp[] = v_exp.elementAt(cmbindex).toString().split("#");
         return Integer.parseInt(tmp[0].trim());
    }
    return -1;
  }


  public void writeToFile(String file, String text){
    try {
          FileOutputStream fos = new FileOutputStream(file);
          Writer out = null;
          out = new OutputStreamWriter(fos);
          out.write(text);
          out.close();
    } catch (IOException e) {
        e.printStackTrace();
    }
  }

  public String showFile(String program, String file){
    try{
      String str ="";
      if(program.trim().equals(""))
        str = file;
      else
        str = program+" "+file;
      Runtime.getRuntime().exec(str);
    }catch(Exception e){
      e.printStackTrace();
      return null;
    }
    return file;
  }

  /**
 * Every other participant shall be provided the image selection in reverse order to see if the time of evaluation has an impact on performance
 * @param v_imagepairs
 * @return
 */
  public static Vector reverseIfMod2(Vector v_imagepairs, int participant_ID){
    Vector ret=new Vector();
    if(participant_ID%2==0){//Run in reverse order
      for(int j=v_imagepairs.size()-1; j>=0;j--){
         ret.addElement(v_imagepairs.elementAt(j));
      }
    }else{//Run in right order
      ret =v_imagepairs;
    }
    return ret;
  }


}