import  java.awt.Dimension;
import  java.awt.Toolkit;
import  javax.swing.JFrame;
import  javax.swing.JDialog;
import java.awt.Point;
import java.awt.Window;
import java.util.Vector;
import java.io.File;


public class Functions {
  public static int EXPERIMENT_ID = 1; //1= without hair, 2= with hair


  public Functions() {
  }

  public static void centerVindu (JFrame f) {
        Dimension skjermSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension vinduSize = f.getSize();
        if (vinduSize.height > skjermSize.height) {
            vinduSize.height = skjermSize.height;
        }
        if (vinduSize.width > skjermSize.width) {
            vinduSize.width = skjermSize.width;
        }
        f.setLocation((skjermSize.width - vinduSize.width)/2, (skjermSize.height
                - vinduSize.height)/2);
  }

  public static void centerVindu (JDialog f) {
        Dimension skjermSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension vinduSize = f.getSize();
        if (vinduSize.height > skjermSize.height) {
            vinduSize.height = skjermSize.height;
        }
        if (vinduSize.width > skjermSize.width) {
            vinduSize.width = skjermSize.width;
        }
        f.setLocation((skjermSize.width - vinduSize.width)/2, (skjermSize.height
                - vinduSize.height)/2);
  }

/**
 * Every other participant shall be provided the image selection in reverse order to see if the time of evaluation has an impact on performance
 * @param v_imagepairs
 * @return
 */
  public static Imagepair[] getImagepairs(Vector v_imagepairs, int participant_ID){
    Imagepair img_pair[] = new Imagepair[v_imagepairs.size()];
    if(participant_ID%2==0){//Run in reverse order
      for(int i=0,j=img_pair.length-1; i<img_pair.length;i++,j--){
         img_pair[i] = (Imagepair)v_imagepairs.elementAt(j);
      }
    }else{//Run in right order
      for(int i=0; i<img_pair.length;i++){
         img_pair[i] = (Imagepair)v_imagepairs.elementAt(i);
      }
    }
    return img_pair;
  }


  public static String[] getDegreeNames(Vector vdegrees){
    String ret[]= null;
    if(!vdegrees.isEmpty()){
      ret = new String[vdegrees.size()];
      for(int i=0;i<vdegrees.size();i++){
          String tmp = vdegrees.elementAt(i).toString().trim();
          String tmp_arr[] = tmp.split("#");
          ret[i]=tmp_arr[1];
      }
    }
    return ret;
  }

  public static int getDegreeID(Vector vdegrees, int selected_index){
    int ret=-1;
    if(!vdegrees.isEmpty()){
          String tmp = vdegrees.elementAt(selected_index).toString().trim();
          String tmp_arr[] = tmp.split("#");
          ret=Integer.parseInt(tmp_arr[0]);
    }
    return ret;
  }





}