import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import com.borland.jbcl.layout.*;

public class GUI_Comparison extends JDialog implements Constants{
  private JPanel jPanel1 = new JPanel();
  private JPanel pnlHeader = new JPanel();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JPanel jPanel3 = new JPanel();
  private JButton btnDifferent = new JButton();
  private JButton btnAlike = new JButton();
  private BorderLayout borderLayout1 = new BorderLayout();
  private BorderLayout borderLayout2 = new BorderLayout();
  private JPanel jPanel2 = new JPanel();
  private JPanel jPanel4 = new JPanel();
  private BoxLayout2 boxLayout21 = new BoxLayout2();
  private JPanel pnlImage1 = new JPanel();
  private JPanel pnlImage2 = new JPanel();
  private BorderLayout borderLayout3 = new BorderLayout();
  private BorderLayout borderLayout4 = new BorderLayout();
  private String imagepath1="";
  private String imagepath2="";
  private boolean isalike = false;
  private DBController dbControll;
  private Timer timer;
  private JTextField txtfTimeLeft = new JTextField(SECONDS_LIMIT);
  private JLabel lblTimeLeft = new JLabel();
  private int sek = SECONDS_LIMIT;


  public GUI_Comparison(JFrame parent, DBController dbControll, String imagepath1, String imagepath2, int currentimagepair, int totalimagepair) {
    super(parent, "Image pair "+currentimagepair+" of "+totalimagepair, true);
    this.dbControll = dbControll;
    this.imagepath1 = imagepath1;
    this.imagepath2 = imagepath2;
    try {
      jbInit();
      this.setSize(COMP_SIZE_W, COMP_SIZE_H);
      Functions.centerVindu(this);
      this.setResizable(false);
      timer.start();//Initiate the timer
      this.show();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void updateSecond(){
    sek--;
  }
  public int getSecond(){
    return sek;
  }

  public boolean isAlike(){
    return isalike;
  }



  private void jbInit() throws Exception {
    txtfTimeLeft.setBackground(this.btnAlike.getBackground());
    txtfTimeLeft.setFont(new java.awt.Font("SansSerif", 1, 14));
    timer = new Timer(ONE_SECOND, new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                txtfTimeLeft.setText(" "+getSecond());
                if (getSecond()<=0) {
                    timeexided();
                }
                updateSecond();
            }
        });
    pnlHeader.setPreferredSize(new Dimension(10, 70));
    pnlHeader.setLayout(borderLayout1);
    jPanel1.setPreferredSize(new Dimension(10, 50));
    btnDifferent.setText(BTN_DIFFERENT_TEXT);
    btnDifferent.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnDifferent_actionPerformed(e);
      }
    });
    btnAlike.setText(BTN_ALIKE_TEXT);
    btnAlike.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnAlike_actionPerformed(e);
      }
    });
    jPanel3.setLayout(borderLayout2);
    jPanel2.setMinimumSize(new Dimension(10, 40));
    jPanel4.setLayout(boxLayout21);
    pnlImage1.setLayout(borderLayout3);
    pnlImage2.setLayout(borderLayout4);
    lblTimeLeft.setText(LBL_TIME_LEFT_TEXT);
    txtfTimeLeft.setBorder(null);
    txtfTimeLeft.setEditable(false);
    this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    jPanel2.add(lblTimeLeft, null);
    jPanel2.add(txtfTimeLeft, null);
//    txtfTimeLeft.setPreferredSize(new Dimension(30, 20));
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(btnAlike, null);
    jPanel1.add(btnDifferent, null);
    this.getContentPane().add(pnlHeader, BorderLayout.NORTH);
    this.getContentPane().add(jScrollPane1,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jPanel3, null);
    jPanel3.add(jPanel4, BorderLayout.CENTER);
    jPanel4.add(pnlImage1, null);
    jPanel4.add(pnlImage2, null);
    jPanel3.add(jPanel2, BorderLayout.NORTH);
    pnlHeader.add(new JLabel(new ImageIcon(COMP_HEADER_IMG_PATH)), BorderLayout.CENTER);
    pnlImage1.add(new JLabel(new ImageIcon(imagepath1)), BorderLayout.CENTER);
    pnlImage2.add(new JLabel(new ImageIcon(imagepath2)), BorderLayout.CENTER);
  }

  void btnAlike_actionPerformed(ActionEvent e) {
    isalike = true;
    timer.stop();
    this.dispose();
  }

  void btnDifferent_actionPerformed(ActionEvent e) {
    isalike = false;
    timer.stop();
    this.dispose();
  }

  void timeexided() {
    Toolkit.getDefaultToolkit().beep();
    timer.stop();
    this.setVisible(false);
    TimeExceeded comp = new TimeExceeded(this);
    comp.addWindowListener(new WindowAdapter(){
        public void windowClosing(WindowEvent e){
          //Do nothing. Prevent the user from closing the window with the cross in the right upper corner
        }
      });
    isalike = comp.isAlike();
    this.dispose();
  }
}