import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.sql.SQLException;

public class GUI_Finished extends JFrame implements Constants{
  private JPanel pnlHeader = new JPanel();
  private JPanel jPanel2 = new JPanel();
  private JButton btnFinish = new JButton();
  private DBController dbControll;
  private BorderLayout borderLayout1 = new BorderLayout();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JEditorPane edtFinishedText = new JEditorPane();



  public GUI_Finished(DBController dbControll) {
    super((Functions.EXPERIMENT_ID==WITH_HAIR?HEADER_FRAME_REGISTRATION_WITHHAIR:HEADER_FRAME_REGISTRATION_WITHOUTHAIR));
    this.dbControll = dbControll;
    try {
      jbInit();
      this.setSize(REG_SIZE_W, REG_SIZE_H);
      Functions.centerVindu(this);
      this.setResizable(false);
      this.show();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    pnlHeader.setPreferredSize(new Dimension(10, 70));
    pnlHeader.setLayout(borderLayout1);
    jPanel2.setPreferredSize(new Dimension(10, 50));
    btnFinish.setText(BTN_FINISH_TEXT);
    btnFinish.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnFinish_actionPerformed(e);
      }
    });
    edtFinishedText.setBackground(this.btnFinish.getBackground());
    edtFinishedText.setEditable(false);
    edtFinishedText.setContentType("text/html");
    edtFinishedText.setText(EDT_FINISHED_TEXT);
    jScrollPane1.setBorder(null);
    this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    this.getContentPane().add(pnlHeader, BorderLayout.NORTH);
    this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(btnFinish, null);
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(edtFinishedText, null);
    pnlHeader.add(new JLabel(new ImageIcon(REG_HEADER_IMG_PATH)), BorderLayout.CENTER);
  }




  void btnFinish_actionPerformed(ActionEvent e) {
    try{
      dbControll.shutdown();
    }catch(SQLException sqle){}
    System.exit(0);
  }
}